[LiteJS]: https://www.litejs.com/
[npm package]: https://npmjs.org/package/litejs
[GitHub repo]: https://github.com/litejs/litejs
[wiki]: https://github.com/litejs/litejs/wiki
[RFC 6570]: http://tools.ietf.org/html/rfc6570


LiteJS
======

The best way to build fast and powerful web interfaces.

Weighing in at just 28KB (12KB gzipped),
it includes everything you need to build a modern web application:

 - routed views with browser history management
 - reusable templates and custom elements
 - asynchronous and dynamic code loading
 - translations with instant language switching - no page reload required
<details>
    <summary>.. and more with no dependencies</summary>

 - [date parsing and formating](https://github.com/litejs/litejs/wiki/Date)
 - string formating
 - [keyboard shortcuts](https://github.com/litejs/litejs/wiki/Keyboard-shortcuts)

</details>
<p></p>

See a [working example](https://cdn.rawgit.com/litejs/litejs/master/test/ui/example1.html)
with a [source code](https://github.com/litejs/litejs/blob/master/test/ui/example1.html)
in 80 lines.
It is also possible to build full SVG single-page applications
([example](https://cdn.rawgit.com/litejs/litejs/master/test/ui/svg-example1.html)
with a [source code](https://github.com/litejs/litejs/blob/master/test/ui/svg-example1.html)
in 60 lines).


## Get Started

Build your first LiteJS app with in 5 minute [Quick Start Guide](https://github.com/litejs/litejs/wiki/Quick-Start).
See [wiki][] for more.


## External links

[GitHub repo][] |
[npm package][] |
[Travis CI](https://travis-ci.org/litejs/litejs) |
[Coveralls code coverage](https://coveralls.io/github/litejs/litejs)


## Licence

Copyright (c) 2013-2019 Lauri Rooden &lt;lauri@rooden.ee&gt;  
[The MIT License](http://lauri.rooden.ee/mit-license.txt)


